; QUICKCAM ROUTINES FOR QUICKSCAN INTERFACE, V1
; HIS ROUTINE SPECIFICALLY MADE TO TAKE 160X100 FRAMES.

.ORG $0801

POINTER = $FE

CIA1TIMERA = $DC04
CIA2TIMERA = $DD04
SP1 = $DC0C
SP2 = $DD0C
PORTA = $DD00
PORTB = $DD01
DDRPORTA = $DD02
DDRPORTB = $DD03
CIA1CRA = $DC0E
CIA2CRA = $DD0E

  SEI
  LDA #$36
  STA $01                ; ILL  .
  STA $D07E
  STA $D075              ; ANK 1 OPTIMIZE
  STA $D07F
  LDA #$80               ; BITMAP = $4000, VIDEOMATRIX = $6000
  STA $D018
  LDA $DD00
  AND #$F0
  ORA #$02
  STA $DD00
  STA PORTADEF           ; EFAULT IS 2 LOW, /3 HIGH, USE  ANK 1
  LDA #$3B               ; ND TURN THE BITMAP ON
  STA $D011
  LDA #$D8               ; ET ULTICOLOR MODE 
  STA $D016
  LDA #$0F               ; ET COLORMATRIX TO LIGHT GREY
  LDX #0
  STX $D020              ; LACK BACKGROUND
  STX $D021
- STA $D800,X
  STA $D900,X
  STA $DA00,X
  STA $DB00,X
  DEX
  BNE -
  LDA #$BC               ; AND VIDEO MATRIX HOLDS THE OTHER TWO GREYS
- STA $6000,X
  STA $6100,X
  STA $6200,X
  STA $6300,X
  DEX
  BNE -

  LDA #64
  STA CIA1CRA        ; ERIAL PORTS ARE OUTPUTS, TIMERS ARE OFF.
  STA CIA2CRA
  JSR RITE_ODE
  LDA #4             ; TIMER MAX SPEED = EVERY 4TH CYCLE.
  STA CIA1TIMERA
  STA CIA2TIMERA
  LDA #0
  STA CIA1TIMERA+1
  STA CIA2TIMERA+1
  LDA #65
  STA CIA1CRA        ; ESTART TIMERS.  IMER  BOTH S = CONTINUOUS
  STA CIA2CRA
  LDA #0
  STA SP1            ; RESET THE CAMERA (1 = LOW)
  STA SP2            ; ISABLE NYBBLE BUS (2 = LOW)
  LDA #59
  STA DDRPORTA
  LDA PORTADEF
  ORA #$08           ; SET BIT 3 (DRIVES /3 LOW, 2 = DON'T CARE)
  STA PORTA
  JSR ESET_AM
  JSR ESET_AM      ; LWAYS CALL THIS TWICE

  LDA #130            ; ET DEFAULT EXPOSURE
  STA EXPOSURE
  LDX #11
  JSR END_OMMAND
  LDA #1             ; ET TOP OF FRAME TO LINE 1
  LDX #13
  JSR END_OMMAND
  LDA #1              ; ET LEFT EDGE OF FRAME TO COLUMN 1
  LDX #15
  JSR END_OMMAND
  LDA #100            ; UMBER OF LINES TO TRANSFER = 100
  LDX #17
  JSR END_OMMAND
  LDA #80            ; RANSFERS PER LINE = 80 (160/2 = 80)
  LDX #19
  JSR END_OMMAND
  LDA #180            ; ET CONTRAST TO 180
  LDX #25
  JSR END_OMMAND
  LDA #0             ; UTO-CALIBRATE THE LACK-EVEL ("FFSET")
  LDX #27
  JSR END_OMMAND

- LDX #33            ; WAIT UNTIL ETFFSET RETURNS SOMETHING OTHER
  JSR ET_ARAMETER  ; THAN 255.
  CMP #255
  BEQ -
 
ET_RAME_OOP
  LDA $DC01
  CMP #254           ; ECREASE BRIGHTNESS (EXPOSURE TIME)
  BNE +
  DEC EXPOSURE
  BNE ++
  LDA #1
  STA EXPOSURE
  JMP OWNLOAD_RAME
+ CMP #247           ; NCREASE BRIGHTNESS
  BNE +
  INC EXPOSURE
  BNE +  
  LDA #255
  STA EXPOSURE
  JMP OWNLOAD_RAME
+ CMP #239
  BNE OWNLOAD_RAME
  LDA #$37
  STA $01
  JSR 65412
  JSR 65511
  JSR 65451
  JSR 65454
  LDA #8
  STA $D016
  LDA #21
  STA $D018
  LDA #27
  STA $D011
  LDA #147
  JSR $FFD2
  CLI
  LDA #0
  STA $D07E                ; RETURN TO STANDARD OPT.
  STA $D077
  STA $D07F
  RTS

OWNLOAD_RAME
  JSR RITE_ODE
  LDA EXPOSURE
  LDX #11
  JSR END_OMMAND
  LDA #8
  STA FLAG           ; TART FLAG LOW (INVERTED: 8=LOW, 0=HIGH)
  LDA #4             ; 4-BIT GREYS, NYBBLE BUS, 2:1 TRANSFERS, NO TEST PATT.
  LDX #7
  JSR END_OMMAND  
  JSR EAD_ODE
  LDA #<16000       ; E'LL GET 16000 SAMPLE NYBBLES (160X100 FRAME)
  STA COUNTER
  LDA #>16000
  STA COUNTER+1
  LDY #0             ; ND STORE TO A BUFFER AT $8000-$
  STY POINTER
  LDA #$80
  STA POINTER+1

- LDA FLAG           ; OGGLE CK LINE AND FLAG
  EOR #$08
  STA FLAG
  ORA PORTADEF       ; DD DEFAULT PORT SETTING
  STA PORTA
  LDA FLAG           ; IF FLAG = $08, /3 GOES 
  BEQ AIT2

AIT1
  LDA PORTA
  AND #$04
  BNE AIT1
  BEQ ET_AMPLE

AIT2
  LDA PORTA
  AND #$04
  BEQ AIT2

ET_AMPLE
  LDA PORTB
  AND #$0F
  EOR #$08
  TAX
  LDA GREYS,X      ; ONVERT FROM UICKCAM PALETTE TO STANDARD GREYSCALE
  STA (POINTER),Y
  INY               ; OINTER = POINTER + 1
  BNE +
  INC POINTER+1
+ SEC
  LDA COUNTER       ; COUNTER = COUNTER - 1
  SBC #1
  STA COUNTER
  LDA COUNTER+1
  SBC #0
  STA COUNTER+1
  ORA COUNTER
  BNE -             ; EEP GOING TILL WE'RE DONE.
  LDA PORTADEF      ; ULL /3 HIGH ONE LAST TIME (PORTADEF DOES THAT)
  STA PORTA         ; TORE TWICE TO FORCE A NICE LONG PAUSE
  STA PORTA
  ORA #$08          ; ND LOW AGAIN.  ND OF FRAME PULSE ($08 = /3 LOW)
  STA PORTA
  JSR $1000         ; ALL _D'S RENDERER
  JMP ET_RAME_OOP


END_OMMAND         ; NTER WITH . = COMMAND, . = DATA
  STA TEMPA
  JSR RITE_ODE     ; ET PORT FOR 8 BIT WRITE MODE
  STX PORTB          ; WRITE COMMAND TO PORT 
  LDA PORTADEF       ; DRIVE /3 (CK) HIGH
  STA PORTA

- LDA PORTA
  AND #$04           ; ATCH FOR 2 (AMDY1) TO GO HIGH
  BEQ -
  LDA PORTADEF       ; RIVE /3 LOW
  ORA #$08
  STA PORTA
- LDA PORTA
  AND #$04           ; AIT FOR 2 TO GO LOW
  BNE -
  LDA TEMPA
  STA PORTB          ; WRITE PARAMETER TO PORT 
  LDA PORTADEF
  STA PORTA          ; RIVE /3 HIGH  
- LDA PORTA
  AND #$04           ; AIT FOR 2 TO GO HIGH
  BEQ -
  LDA PORTADEF       ; RIVE /3 LOW
  ORA #$08
  STA PORTA
- LDA PORTA
  AND #$04           ; ...AND WAIT FOR 2 TO RESPOND
  BNE -
  RTS

ET_ARAMETER
  STA TEMPA
  JSR RITE_ODE
  LDA TEMPA
  STA PORTB
  LDA PORTADEF       ; ET /3 HIGH
  STA PORTA
- LDA PORTA          ; ANT FOR CAMERA TO RESPOND
  AND #$04
  BEQ -
  LDA PORTADEF       ; ND LOW..
  ORA #$08
  STA PORTA
- LDA PORTA          ; WAIT AGAIN
  AND #$04
  BNE -
  LDA PORTADEF           ; IGH AGAIN..
  STA PORTA
- LDA PORTA          ; AIT FOR CAM TO RESPOND
  AND #$04
  BEQ -
  JSR EAD_ODE      ; WITCH TO READ MODE
  LDA PORTB          ; ET HIGH NYBBLE
  EOR #$08
  ASL
  ASL
  ASL
  ASL
  STA TEMPB
  LDA PORTADEF           ; RIVE /3 LOW
  ORA #$08
  STA PORTA
- LDA PORTA
  AND #$04           ; AIT FOR CAM TO RESPOND
  BNE -
  LDA PORTB          ; ET LOW NYBBLE
  AND #$0F           ; FIX IT
  EOR #$08
  ORA TEMPB          ; AND MIX IT
  PHA                ; STASH .
  JSR RITE_ODE     ; ETURN TO WRITE MODE
  PLA                ; RECALL . FOR PROCESSING
  RTS

RITE_ODE
  LDA #255
  STA DDRPORTB      ; ...AND ALL OF 0-7 AS OUTPUTS
  LDA #0
  STA SP2           ; ET YBBLE BUS MODE OFF
  RTS

EAD_ODE
  LDA #0
  STA DDRPORTB     ; ET ALL LINES AS INPUTS (7..4 = DON'T CARE)
  LDA #255
  STA SP2          ; ET YBBLE BUS ON
  RTS

ESET_AM
  LDA #0
  STA SP1
  LDA #255
  STA SP1
- LDA PORTA
  AND #$04
  BNE -
  RTS

TEMP
.BYTE 0
TEMPCOLUMNS
.BYTE 0
TEMPROWS
.BYTE 0
EXPOSURE
.BYTE 0
FLAG
.BYTE 0
TEMPA
.BYTE 0
TEMPB
.BYTE 0
PORTADEF
.BYTE 0
COUNTER
.BYTE 0,0
GREYS
.BYTE 0,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1

; BLK          WHT
; 0FEDCBA987654321

