; QUICKCAM ROUTINES FOR QUICKSCAN INTERFACE, V1

.ORG $2000

POINTER1 = $FA
POINTER2 = $FC

CIA1TIMERA = $DC04
CIA2TIMERA = $DD04
SP1 = $DC0C
SP2 = $DD0C
PORTA = $DD00
PORTB = $DD01
DDRPORTA = $DD02
DDRPORTB = $DD03
CIA1CRA = $DC0E
CIA2CRA = $DD0E

JMP IVE_IDEO
JMP EN_HARSET
JMP ISPLAY_RAME

IVE_IDEO
 JSR NIT_AMERA
 JMP ET_RAME_OOP

ISPLAY_RAME
  JSR NIT_AMERA
  JSR OWNLOAD_RAME
  JSR ENDER_RAME
  JSR 65412
  JSR 65511
  JSR 65451
  JSR 65454
  RTS

NIT_AMERA
  SEI
  LDA #8
  STA $D011              ; LANK THE SCREEN FOR A BIT.
  LDA #0 
  STA $D020
  STA $D021              ; BLACK BACKROUND (FOR BITPAIR = %00)
  LDA #11
  STA $D022              ; K. GREY SECOND BACKGROUND (FOR BITPAIR = %01)
  LDA #15                ; T GREY THIRD BACKGROUND (BITPAIR = %10
  STA $D023
  LDA #$12
  STA $D018              ; CHARSET = $0800, VIDEOMATRIX = $0400
  LDA #$D8               ; NABLE MULTICOLOR MODE
  STA $D016
  JSR EN_HARSET        ; OW CREATE THE CHARACTERSET
  STA $D07E
  STA $D076
  STA $D07F
  LDA #185
  STA EXPOSURE
  LDA #$09               ; WHITE FOREGROUND, ALL CHARS ARE 
  LDX #0                 ; %XXXX1001 : BIT 3 = SET  MODE, 2-0 = COLOR.
- DEX                    ; FOR BITPAIR = %11
  STA $D800,X
  STA $D900,X
  STA $DA00,X
  STA $DB00,X
  BNE -
  LDA #64
  STA CIA1CRA        ; ERIAL PORTS ARE OUTPUTS, TIMERS ARE OFF.
  STA CIA2CRA
  JSR RITE_ODE
  LDA #4             ; TIMER MAX SPEED = EVERY 4TH CYCLE.
  STA CIA1TIMERA
  STA CIA2TIMERA
  LDA #0
  STA CIA1TIMERA+1
  STA CIA2TIMERA+1
  LDA #65
  STA CIA1CRA        ; ESTART TIMERS.  IMER  BOTH S = CONTINUOUS
  STA CIA2CRA
  LDA #0
  STA SP1            ; RESET THE CAMERA (1 = LOW)
  STA SP2            ; ISABLE NYBBLE BUS (2 = LOW)
  LDA #59
  STA DDRPORTA
  LDA #251
  STA PORTA          ; DRIVE /3 LOW (2 = DON'T CARE)
  JSR ESET_AM
  JSR ESET_AM      ; LWAYS CALL THIS TWICE

  LDA #180            ; ET DEFAULT EXPOSURE
  STA EXPOSURE
  LDX #11
  JSR END_OMMAND
  LDA #40             ; ET TOP OF FRAME TO LINE 40
  LDX #13
  JSR END_OMMAND
  LDA #20             ; ET LEFT EDGE OF FRAME TO COLUMN 40
  LDX #15
  JSR END_OMMAND
  LDA #50            ; UMBER OF LINES TO TRANSFER = 50
  LDX #17
  JSR END_OMMAND
  LDA #40            ; RANSFERS PER LINE = 40 (80/2 = 40)
  LDX #19
  JSR END_OMMAND
  LDA #180            ; ET CONTRAST TO 180
  LDX #25
  JSR END_OMMAND
  LDA #0             ; UTO-CALIBRATE THE LACK-EVEL ("FFSET")
  LDX #27
  JSR END_OMMAND

- LDX #33            ; WAIT UNTIL ETFFSET RETURNS SOMETHING OTHER
  JSR ET_ARAMETER  ; THAN 255.
  CMP #255
  BEQ -
  LDA #27
  STA $D011          ; NBLANK THE SCREEN
  RTS
 
ET_RAME_OOP
  LDA $DC01
  CMP #254           ; ECREASE BRIGHTNESS (EXPOSURE TIME)
  BNE +
  DEC EXPOSURE
  BNE ++
  LDA #1
  STA EXPOSURE
  JMP ET_RAME

+ CMP #247           ; NCREASE BRIGHTNESS
  BNE +
  INC EXPOSURE
  BNE +  
  LDA #255
  STA EXPOSURE
  JMP ET_RAME

+ CMP #239
  BNE ET_RAME
  JSR 65412
  JSR 65511
  JSR 65451
  JSR 65454
  LDA #8
  STA $D016
  LDA #21
  STA $D018
  LDA #147
  JSR $FFD2
  CLI
  STA $D07E
  STA $D077
  STA $D07F
  RTS   

ET_RAME
  JSR OWNLOAD_RAME
  JSR ENDER_RAME
  JMP ET_RAME_OOP

OWNLOAD_RAME
  JSR RITE_ODE
  LDA EXPOSURE
  LDX #11
  JSR END_OMMAND
  LDA #8
  STA FLAG           ; TART FLAG LOW (INVERTED: 8=LOW, 0=HIGH)
  LDA #8             ; 4-BIT GREYS, NYBBLE BUS, 4:1 TRANSFERS, NO TEST PATT.
  LDX #7
  JSR END_OMMAND  
  JSR EAD_ODE
  LDA #$A0       ; E'LL GET 4000 SAMPLE NYBBLES (80X50 FRAME)
  STA COUNTER
  LDA #$0F
  STA COUNTER+1
  LDY #0             ; ND STORE TO A BUFFER AT $C000
  STY POINTER2
  LDA #$C0
  STA POINTER2+1

- LDA FLAG           ; OGGLE CK LINE AND FLAG
  EOR #$08
  STA FLAG
  ORA #243
  STA PORTA
  LDA FLAG            ; LAG = $08 = 
  BEQ AIT2

AIT1
  LDA PORTA
  AND #$04
  BNE AIT1
  BEQ ET_AMPLE

AIT2
  LDA PORTA
  AND #$04
  BEQ AIT2

ET_AMPLE
  LDA PORTB
  AND #$0F
  EOR #$08
  TAX
  LDA GREYS,X      ; ONVERT FROM UICKCAM PALETTE TO STANDARD GREYSCALE
  STA (POINTER2),Y
  INY               ; OINTER = POINTER + 1
  BNE +
  INC POINTER2+1
+ SEC
  LDA COUNTER       ; COUNTER = COUNTER - 1
  SBC #1
  STA COUNTER
  LDA COUNTER+1
  SBC #0
  STA COUNTER+1
  ORA COUNTER
  BNE -             ; EEP GOING TILL WE'RE DONE.
  LDA #243          ; ULL /3 HIGH ONE LAST TIME
  STA PORTA         ; TORE TWICE TO FORCE A NICE LONG PAUSE
  STA PORTA
  LDA #251          ; ND LOW AGAIN.  ND OF FRAME PULSE.
  STA PORTA
  RTS 

END_OMMAND         ; NTER WITH . = COMMAND, . = DATA
  STA TEMPA
  JSR RITE_ODE     ; ET PORT FOR 8 BIT WRITE MODE
  STX PORTB          ; WRITE COMMAND TO PORT 
  LDA #243           ; DRIVE /3 (CK) HIGH
  STA PORTA
- LDA PORTA
  AND #$04           ; ATCH FOR 2 (AMDY1) TO GO HIGH
  BEQ -
  LDA #251           ; RIVE /3 LOW
  STA PORTA
- LDA PORTA
  AND #$04           ; AIT FOR 2 TO GO LOW
  BNE -
  LDA TEMPA
  STA PORTB          ; WRITE PARAMETER TO PORT 
  LDA #243
  STA PORTA          ; RIVE /3 HIGH  
- LDA PORTA
  AND #$04           ; AIT FOR 2 TO GO HIGH
  BEQ -
  LDA #251           ; RIVE /3 LOW
  STA PORTA
- LDA PORTA
  AND #$04           ; ...AND WAIT FOR 2 TO RESPOND
  BNE -
  RTS

ET_ARAMETER
  STA TEMPA
  JSR RITE_ODE
  LDA TEMPA
  STA PORTB
  LDA #243           ; ET /3 HIGH
  STA PORTA
- LDA PORTA          ; ANT FOR CAMERA TO RESPOND
  AND #$04
  BEQ -
  LDA #251           ; ND LOW..
  STA PORTA
- LDA PORTA          ; WAIT AGAIN
  AND #$04
  BNE -
  LDA #243           ; IGH AGAIN..
  STA PORTA
- LDA PORTA          ; AIT FOR CAM TO RESPOND
  AND #$04
  BEQ -
  JSR EAD_ODE      ; WITCH TO READ MODE
  LDA PORTB          ; ET HIGH NYBBLE
  EOR #$08
  ASL
  ASL
  ASL
  ASL
  STA TEMPB
  LDA #251           ; RIVE /3 LOW
  STA PORTA
- LDA PORTA
  AND #$04           ; AIT FOR CAM TO RESPOND
  BNE -
  LDA PORTB          ; ET LOW NYBBLE
  AND #$0F           ; FIX IT
  EOR #$08
  ORA TEMPB          ; AND MIX IT
  PHA                ; STASH .
  JSR RITE_ODE     ; ETURN TO WRITE MODE
  PLA                ; RECALL . FOR PROCESSING
  RTS

RITE_ODE
  LDA #255
  STA DDRPORTB      ; ...AND ALL OF 0-7 AS OUTPUTS
  LDA #0
  STA SP2           ; ET YBBLE BUS MODE OFF
  RTS

EAD_ODE
  LDA #0
  STA DDRPORTB     ; ET ALL LINES AS INPUTS (7..4 = DON'T CARE)
  LDA #255
  STA SP2          ; ET YBBLE BUS ON
  RTS

ESET_AM
  LDA #0
  STA SP1
  LDA #255
  STA SP1
- LDA PORTA
  AND #$04
  BNE -
  RTS

ENDER_RAME
  LDA #0
  STA POINTER1
  LDA #$C0
  STA POINTER1+1

  LDA #0
  STA POINTER2
  LDA #4
  STA POINTER2+1
  LDA #40
  STA TEMPCOLUMNS       ; # OF COLUMNS ON TARGET MATRIX
  LDA #25
  STA TEMPROWS          ; # OF ROWS

ENDER_INE
  LDY #0
  LDA (POINTER1),Y
  AND #$0C              ; IRST SAMPLE ALWAYS USES BITS 3 AND 2.
  STA TEMP
  LDY #1
  LDA (POINTER1),Y
  LSR
  LSR
  ORA TEMP
  ASL
  ASL
  STA TEMP
  LDY #80
  LDA (POINTER1),Y
  LSR
  LSR
  ORA TEMP
  ASL
  ASL
  STA TEMP
  LDY #81
  LDA (POINTER1),Y
  LSR
  LSR
  ORA TEMP
  LDY #0
  STA (POINTER2),Y
  CLC
  LDA POINTER1
  ADC #2
  STA POINTER1
  LDA POINTER1+1
  ADC #0
  STA POINTER1+1
  CLC
  LDA POINTER2
  ADC #1
  STA POINTER2
  LDA POINTER2+1
  ADC #0
  STA POINTER2+1
  DEC TEMPCOLUMNS
  BEQ +
  JMP ENDER_INE

+ CLC
  LDA POINTER1
  ADC #80
  STA POINTER1
  LDA POINTER1+1
  ADC #0
  STA POINTER1+1
  DEC TEMPROWS
  BEQ +
  LDA #40
  STA TEMPCOLUMNS
  JMP ENDER_INE

+ RTS

EN_HARSET
  LDX #0
  LDY #0
  STY TEMP
  STY POINTER2
  LDA #$08
  STA POINTER2+1  

RAW_HAR
  LDA TEMP
  AND #$0F
  TAX
  LDA CHARTABLE,X
  LDY #4

- STA (POINTER2),Y
  INY
  CPY #8
  BNE -

  LDA TEMP
  LSR
  LSR
  LSR
  LSR
  TAX
  LDA CHARTABLE,X
  LDY #0

- STA (POINTER2),Y  
  INY
  CPY #4
  BNE -

  INC TEMP
  CLC
  LDA POINTER2
  ADC #8
  STA POINTER2
  LDA POINTER2+1
  ADC #0
  STA POINTER2+1
  CMP #$10
  BNE RAW_HAR
  RTS

TEMP
.BYTE 0
TEMPCOLUMNS
.BYTE 0
TEMPROWS
.BYTE 0
EXPOSURE
.BYTE 0
FLAG
.BYTE 0
TEMPA
.BYTE 0
TEMPB
.BYTE 0
COUNTER
.BYTE 0,0
GREYS
.BYTE 0,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1

CHARTABLE
.BYTE %00000000
.BYTE %00000101
.BYTE %00001010
.BYTE %00001111
.BYTE %01010000
.BYTE %01010101
.BYTE %01011010
.BYTE %01011111
.BYTE %10100000
.BYTE %10100101
.BYTE %10101010
.BYTE %10101111
.BYTE %11110000
.BYTE %11110101
.BYTE %11111010
.BYTE %11111111

; BLK          WHT
; 0FEDCBA987654321

