; QUICKCAM ROUTINES FOR QUICKSCAN INTERFACE, V1
; HIS ROUTINE SPECIFICALLY MADE TO TAKE 160X100 FRAMES.
; ESIGNED TO USE ARK'S RAZLACE RENDERER.

.ORG $0801

POINTER = $FE

CIA1TIMERA = $DC04
CIA2TIMERA = $DD04
SP1 = $DC0C
SP2 = $DD0C
PORTA = $DD00
PORTB = $DD01
DDRPORTA = $DD02
DDRPORTB = $DD03
CIA1CRA = $DC0E
CIA2CRA = $DD0E

  SEI
  STA $D07E              ; O OPTIMIZATION
  STA $D077
  STA $D07F
  LDA #$36
  STA $01
  LDA $DD00
  AND #$F3               ; EFAULT:  ERIAL LINES ALL HIGH, /3 LOW
  STA $DD00
  LDA #01
  STA $DC0D              ; ISABLE ALL  'S AND 'S
  STA $DD0D
  LDA #64
  STA CIA1CRA            ; ERIAL PORTS ARE OUTPUTS, TIMERS ARE OFF.
  STA CIA2CRA
  JSR RITE_ODE
  LDA #4                 ; TIMER MAX SPEED = EVERY 4TH CYCLE.
  STA CIA1TIMERA
  STA CIA2TIMERA
  LDA #0
  STA CIA1TIMERA+1
  STA CIA2TIMERA+1
  LDA #65
  STA CIA1CRA        ; ESTART TIMERS.  IMER  BOTH S = CONTINUOUS
  STA CIA2CRA
  LDA #0
  STA SP1            ; RESET THE CAMERA (1 = LOW)
  STA SP2            ; ISABLE NYBBLE BUS (2 = LOW)
  LDA #59
  STA DDRPORTA
  LDA PORTA
  ORA #$08           ; SET BIT 3 (DRIVES /3 LOW, 2 = DON'T CARE)
  STA PORTA
  JSR ESET_AM
  JSR ESET_AM      ; LWAYS CALL THIS TWICE

  LDA #160            ; ET DEFAULT EXPOSURE
  STA EXPOSURE
  LDX #11
  JSR END_OMMAND
  LDA #2             ; ET TOP OF FRAME TO LINE 2
  LDX #13
  JSR END_OMMAND
  LDA #7              ; ET LEFT EDGE OF FRAME TO COLUMN 14 (7*2)
  LDX #15
  JSR END_OMMAND
  LDA #200            ; UMBER OF LINES TO TRANSFER = 200
  LDX #17
  JSR END_OMMAND
  LDA #160            ; RANSFERS PER LINE = 160 (320/2 = 160)
  LDX #19
  JSR END_OMMAND
  LDA #180            ; ET CONTRAST TO 180
  LDX #25
  JSR END_OMMAND
  LDA #0             ; UTO-CALIBRATE THE LACK-EVEL ("FFSET")
  LDX #27
  JSR END_OMMAND

- LDX #33            ; WAIT UNTIL ETFFSET RETURNS SOMETHING OTHER
  JSR ET_ARAMETER  ; THAN 255.
  CMP #255
  BEQ -
  JSR $1000          ; NITIALIZE FOR RAZLACE  AND RENDERER 

ET_EXT_RAME
  LDA $DC01
  CMP #254           ; ECREASE BRIGHTNESS (EXPOSURE TIME)
  BNE +
  DEC EXPOSURE
  BNE ++
  LDA #1
  STA EXPOSURE
  JMP TART_OW_OOP
+ CMP #247           ; NCREASE BRIGHTNESS
  BNE +
  INC EXPOSURE
  BNE +  
  LDA #255
  STA EXPOSURE
  JMP TART_OW_OOP
+ CMP #239
  BNE TART_OW_OOP
  SEI
  LDA #$37
  STA $01
  JSR 65412
  JSR 65511
  JSR 65451
  JSR 65454
  LDA #8
  STA $D016
  LDA #21
  STA $D018
  LDA #27
  STA $D011
  LDA #147
  JSR $FFD2
  LDA #0
  STA $D07E                ; RETURN TO STANDARD OPT.
  STA $D077
  STA $D07F
  LDA #$31
  STA $0314
  LDA #$EA
  STA $0315
  LDA #0
  STA $D01A
  CLI
  RTS

TART_OW_OOP
  JSR RITE_ODE
  LDA EXPOSURE
  LDX #11
  JSR END_OMMAND
  LDA #8
  STA FLAG           ; TART FLAG LOW (INVERTED: 8=LOW, 0=HIGH)
  LDA #0             ; 4-BIT GREYS, NYBBLE BUS, 1:1 TRANSFERS, NO TEST PATT.
  STA POINTER
  LDX #7
  JSR END_OMMAND  
  JSR EAD_ODE
  JSR $1006          ; ESET RENDERER CODE TO LINE 0
  LDA #25
  STA ROWCOUNT

ET_EXT_OW
  LDA #<2560         ; E'LL GET 2560 SAMPLE NYBBLES
  STA COUNTER
  LDA #>2560
  STA COUNTER+1
  LDY #0
  LDA #$20
  STA POINTER+1

ET_EXT_YTE
  LDA FLAG           ; OGGLE CK LINE AND FLAG
  EOR #$08
  STA FLAG
  SEI
  LDA PORTA
  AND #$F3
  ORA FLAG
  STA PORTA
  CLI
  LDA FLAG           ; IF FLAG = $08, /3 GOES 
  BEQ AIT2

AIT1
  LDA PORTA
  AND #$04
  BNE AIT1
  BEQ ET_AMPLE

AIT2
  LDA PORTA
  AND #$04
  BEQ AIT2

ET_AMPLE
  LDA PORTB
  AND #$0F
  EOR #$08
  TAX
  LDA GREYS,X      ; ONVERT FROM UICKCAM PALETTE TO STANDARD GREYSCALE
  LDX FLAG         ; F FLAG = 8, _ IS LOW, SO STORE HIGH NYBBLE.
  BEQ +
  ASL
  ASL
  ASL
  ASL
  STA TEMPA
  JMP ++
+ ORA TEMPA
  STA (POINTER),Y
  INY               ; OINTER = POINTER + 1
  BNE +
  INC POINTER+1
+ LDA COUNTER
  BNE +
  DEC COUNTER+1
+ DEC COUNTER
  LDA COUNTER
  ORA COUNTER+1
  BEQ +
  JMP ET_EXT_YTE ; EEP GOING TILL WE'RE DONE.

+ JSR $1003
  DEC ROWCOUNT
  BEQ +
  JMP ET_EXT_OW

+ SEI
  LDA PORTA         ; ULL /3 HIGH ONE LAST TIME
  AND #$F3 
  STA PORTA         ; TORE TWICE TO FORCE A NICE LONG PAUSE
  STA PORTA
  ORA #$08          ; ND LOW AGAIN.  ND OF FRAME PULSE ($08 = /3 LOW)
  STA PORTA
  CLI
  JMP ET_EXT_RAME

END_OMMAND         ; NTER WITH . = COMMAND, . = DATA
  STA TEMPA
  JSR RITE_ODE     ; ET PORT FOR 8 BIT WRITE MODE
  STX PORTB          ; WRITE COMMAND TO PORT 
  LDA PORTA          ; DRIVE /3 (CK) HIGH
  AND #$F3
  STA PORTA
- LDA PORTA
  AND #$04           ; ATCH FOR 2 (AMDY1) TO GO HIGH
  BEQ -
  LDA PORTA          ; RIVE /3 LOW
  ORA #$08
  STA PORTA
- LDA PORTA
  AND #$04           ; AIT FOR 2 TO GO LOW
  BNE -
  LDA TEMPA
  STA PORTB          ; WRITE PARAMETER TO PORT 
  LDA PORTA
  AND #$F3
  STA PORTA          ; RIVE /3 HIGH  
- LDA PORTA
  AND #$04           ; AIT FOR 2 TO GO HIGH
  BEQ -
  LDA PORTA          ; RIVE /3 LOW
  ORA #$08
  STA PORTA
- LDA PORTA
  AND #$04           ; ...AND WAIT FOR 2 TO RESPOND
  BNE -
  RTS

ET_ARAMETER
  STA TEMPA
  JSR RITE_ODE
  LDA TEMPA
  STA PORTB
  LDA PORTA          ; ET /3 HIGH
  AND #$F3
  STA PORTA
- LDA PORTA          ; ANT FOR CAMERA TO RESPOND
  AND #$04
  BEQ -
  LDA PORTA          ; ND LOW..
  ORA #$08
  STA PORTA
- LDA PORTA          ; WAIT AGAIN
  AND #$04
  BNE -
  LDA PORTA          ; IGH AGAIN..
  AND #$F3
  STA PORTA
- LDA PORTA          ; AIT FOR CAM TO RESPOND
  AND #$04
  BEQ -
  JSR EAD_ODE      ; WITCH TO READ MODE
  LDA PORTB          ; ET HIGH NYBBLE
  EOR #$08
  ASL
  ASL
  ASL
  ASL
  STA TEMPB
  LDA PORTA          ; RIVE /3 LOW
  ORA #$08
  STA PORTA
- LDA PORTA
  AND #$04           ; AIT FOR CAM TO RESPOND
  BNE -
  LDA PORTB          ; ET LOW NYBBLE
  AND #$0F           ; FIX IT
  EOR #$08
  ORA TEMPB          ; AND MIX IT
  STA TEMPA          ; STASH .
  JSR RITE_ODE     ; ETURN TO WRITE MODE
  LDA TEMPA          ; RECALL . FOR PROCESSING
  RTS

RITE_ODE
  LDA #255
  STA DDRPORTB      ; ...AND ALL OF 0-7 AS OUTPUTS
  LDA #0
  STA SP2           ; ET YBBLE BUS MODE OFF
  RTS

EAD_ODE
  LDA #0
  STA DDRPORTB     ; ET ALL LINES AS INPUTS (7..4 = DON'T CARE)
  LDA #255
  STA SP2          ; ET YBBLE BUS ON
  RTS

ESET_AM
  LDA #0
  STA SP1
  LDA #255
  STA SP1
- LDA PORTA
  AND #$04
  BNE -
  RTS

TEMP
.BYTE 0
ROWCOUNT
.BYTE 0
EXPOSURE
.BYTE 0
FLAG
.BYTE 0
TEMPA
.BYTE 0
TEMPB
.BYTE 0
COUNTER
.BYTE 0,0
GREYS
.BYTE 0,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1

; BLK          WHT
; 0FEDCBA987654321

